<div class="py-4">
    <p class="text-xl">Page des topics</p>
    <div class="text-center mt-4">
        <div class="inline-block">
            <div class="flex flex-cols gap-4">
                @if (topics !== undefined && pagination !== undefined) {
                    <div>
                        <p-table [value]="topics" styleClass="p-datatable-striped"  [tableStyle]="{ 'min-width': '50rem', 'width': '1000px' }">
                            <ng-template pTemplate="header">
                                <tr>
                                    <th>Titre</th>
                                    <th>Description</th>
                                    <th>Auteur</th>
                                    <th>Créé le</th>
                                    <th>Actions</th>
                                </tr>
                            </ng-template>
                            @if (topics.length > 0) {
                                <ng-template pTemplate="body" let-topic>
                                    <tr class="hover:bg-[#F4ECF5]" (click)="goToTopic(topic.id)">
                                        <td class="cursor-pointer ">{{ topic.title }}</td>
                                        <td class="cursor-pointer ">{{ topic.description }}</td>
                                        <td class="cursor-pointer ">{{ topic.author.firstname }} {{ topic.author.lastname }}</td>
                                        <td class="cursor-pointer ">{{ topic.createdAt | date: 'dd/MM/YYYY HH:mm' }}</td>
                                        <td class="flex justify-around cursor-default">
                                            @if (currentUserId === topic.authorId) {
                                                <span class="border border-blue-500 rounded-lg bg-blue-100 px-2 py cursor-pointer" (click)="onUpdtate(topic.id)" click-stop-propagation>Modifier</span>
                                                <span class="border border-red-500 rounded-lg bg-red-100 px-2 py cursor-pointer" (click)="onDelete(topic.id)" click-stop-propagation>Supprimer</span>
                                            }
                                        </td>
                                    </tr>
                                </ng-template>
                            }
                            @else {
                                <ng-template pTemplate="body">
                                    <tr>
                                        <td colspan="4" class="text-center">Aucun topic trouvé</td>
                                    </tr>
                                </ng-template>
                            }
                        </p-table>
                        <div class="h-4"></div>
                        <p-paginator 
                            (onPageChange)="onPaginationChange($event)" 
                            [first]="currentPage"
                            [rows]="pagination.limit" 
                            [totalRecords]="pagination.totalAmount"
                        />
                    </div>
                    <div>
                        <div class="bg-white rounded-lg border border-[#DADADA] px-5 py-4 flex flex-col gap-4">
                            <div class="flex justify-between items-center">
                                <p>Filtres</p>
                                <app-main-button
                                    [label]="'Créer un topic'"
                                    [isDisabled]="false"
                                    [isLoading]="false"
                                    (onClick)="addTopic()"
                                />
                            </div>
                            <hr/>
                            <form [formGroup]="topicFilterForm">
                                <div class="flex flex-col gap-2">
                                    <div class="flex gap-2 items-center">
                                        <p>Titre : </p>
                                        <app-text-input
                                            [type]="'text'"
                                            [formControlName]="'title'"
                                            [placeholder]="'Titre de du topic'"
                                            [isError]="false"
                                            [guestForm]="topicFilterForm"
                                        />
                                    </div>
                                    <app-main-button
                                        [label]="'Filtrer'"
                                        [isDisabled]="false"
                                        [isLoading]="false"
                                        (onClick)="onFilter()"
                                    />
                                </div>
                            </form>
                        </div>
                    </div>
                }
                @else {
                    <div class="absolute right-1/2 top-1/2 -translate-y-1/2 translate-x-1/2">
                        <p>Chargement des données en cours...</p>
                    </div>
                }
            </div>
        </div>
    </div>
</div>